/* XAES Demonstration ver 1.03
 * by Ken Hollis
 *
 * Demo to show off the usage of XAES functions and what they do.  This
 * demo is not documented, but you may cut and paste any part of it to your
 * own code.  No part of this code may be modified in itself, but you may
 * modify it in your own program.
 *
 * Remember, this is just the test version for now.  Many others will follow
 * as time permits, and as Atari gets their act together in releasing the
 * Extended Object Type information.
 */

#include "obdefs.h"
#include "gemdefs.h"
#include "vdibind.h"
#include "osbind.h"

OBJECT	*menuz,*title,*movable,*ul,*boxes,*popup,*putest,*popbox,*edits,
	*closing1;

#include "mydials.h"
#include "mydials.c"

void	FindDialogs()
{
	FindDialog(MENUZ, &menuz);
	FindDialog(TITLE, &title);
	FindDialog(MOVABLE, &movable);
	FindDialog(UL, &ul);
	FindDialog(BOXES, &boxes);
	FindDialog(POPUP, &popup);
	FindDialog(PUTEST, &putest);
	FindDialog(POPBOX, &popbox);
	FindDialog(EDITS, &edits);
	FindDialog(CLOSING1, &closing1);
}

void	CenterDialogs()
{
	CenterDialog(title);
	CenterDialog(movable);
	CenterDialog(ul);
	CenterDialog(boxes);
	CenterDialog(popup);
	CenterDialog(putest);
	CenterDialog(popbox);
	CenterDialog(edits);
	CenterDialog(closing1);
}

void	ProcessEObT(EObT)
int	EObT;
{
	switch(EObT) {
		case OK_STANDARD:	Private_CloseWindow(CurrWindow);
					break;
		case CANCEL_STANDARD:	Private_CloseWindow(CurrWindow);
					break;
	}
}

main()
{
	int	i;
	MYMSG	msg;
	OBJECT	*ob;

	appl_init();
	ap_id = gl_apid;
	printf("Welcome to XAES.  Copyright (C) 1993, BitGate Software PD\n\n");
	printf("Internal AES library version %d\n",ap_id);
	printf("XAES test library version    0.35\n");
	if (ap_id==-1) {
		printf("Error : Can't initialize GEM.\n\n");
		return(APP_ERR);
	}

	ChangeMouseStyle(ARROW);
	OpenWorkspace();

	if (!rsrc_load("MYDIALS.RSC")) {
		form_alert(1,"[3][Resource file not found!][ Abort! ]");
		CloseWorkspace();
		ExitApplication();
		return(0);
	}

	XAES_InitWindowDialogs();
	i = Initialize_XAES();
	if (i!=XAES_INIT_FAIL) {
		wind_get(DESKTOP_HANDLE,WF_WORKXYWH,&desk.g_x,&desk.g_y,&desk.g_w,&desk.g_h);
		FindDialogs();
		CenterDialogs();
		menu_bar(menuz,1);
		do {
			if (CheckAllClosed()) GetMYMSG(&msg,menuz); else
				i = DoDialogWindow(FALSE,&msg,menuz);
			if (msg.MsgType == MENU_ID) {
				switch(msg.ItemSelected) {
					case ABTXAES:
					case SHOWTITL:	if (!Private_Opened(TITLE)) NewWindowDialog(" Title Screen ",TITLE);
							break;
					case SHOWUL:	if (!Private_Opened(UL)) NewWindowDialog(" Underline Test ",UL);
							break;
					case SHOWFLY:	if (!Private_Opened(MOVABLE)) NewWindowDialog(" Flying Dialog ",MOVABLE);
							break;
					case SHOWBUTN:	if (!Private_Opened(BOXES)) NewWindowDialog(" Box Effects ",BOXES);
							break;
					case SHOWPOP:	if (!Private_Opened(POPUP)) NewWindowDialog(" Popup Dialog ",POPUP);
							break;
					case SHOWEND:	if (!Private_Opened(CLOSING1)) NewWindowDialog(" Closing Screen ",CLOSING1);
							break;
					case SHOWEDIT:	if (!Private_Opened(EDITS)) {
								NewWindowDialog(" Editable Test ",EDITS);
								WStuff.CurrEdit[CurrWindow] = TI1;
							}
							break;
				}
			}
			if (msg.MsgType==OBJC_ID) {
				rsrc_gaddr(R_TREE, WStuff.Dial[CurrWindow],&ob);
				if ((ob[msg.ObjSelected].ob_state & SELECTED) && (msg.ObjSelected!=0)) ProcessEObT(Private_ReturnEObT(ob,msg.ObjSelected));
			}
		} while(msg.ItemSelected!=FILEQUIT);
		ExitApplication;
	}
}
